/**
 * Use the startup phase to tell Thunderbird that it should load
 * our message-content-script.js file whenever a message is displayed
 */
//const photosCache = [[],[]];

const handleStartup = () => {
  messenger.messageDisplayScripts.register({
    js: [{ file: "/src/scf-content.js" }],
    css: [{ file: "/src/scf-styles.css" }],
  });
};

/**
 * command handler: handles the commands received from the content script
 */

const doHandleCommand = async (message, sender) => {
  const { command } = message;
  const {
    tab: { id: tabId },
  } = sender;

  const messageHeader = await browser.messageDisplay.getDisplayedMessage(tabId);
  const local_dir_path = "PhotoLocal";

//  console.log(messageHeader.author);
  var mailColl=[];
  var mailCollFull=[];
  var mailCollsrc=[];
  var picABsrc=[];
  var picLocalsrc=[];
  var nophotoicon = browser.runtime.getURL("src/nophoto.png");
  var priority_place = "AB";

  function mailCollector(to) {
         var mailArr=to;
         var photo_path;
         var cnt=0;

          for (cnt=0; cnt<mailArr.length; cnt++) {
             var trm10= "" + mailArr[cnt] + "";
             mailCollFull.push(""+trm10);
             var trm11= trm10.split("<");
             if (trm11.length!=2) {
                var trm21="" + trm11;
                var trm31= "" + trm21.slice(0, trm21.length) + trm21.slice(trm21.length, trm21.length) + "";
                }
             else {
               var trm21= "" + trm11[1] + "";
               var trm31= "" + trm21.slice(0, trm21.length-1) + trm21.slice(trm21.length, trm21.length) + "";
               };
             mailColl.push(trm31);
          };
   };

   var auth1 = messageHeader.author;
   mailCollFull.push(auth1);
   var auth2 = auth1.split("<");
   var auth3 = "" + auth2[1] + "";
   var auth4 = "" + auth3.slice(0, auth3.length-1) + auth3.slice(auth3.length, auth3.length) + "";
   mailColl.push(auth4);

   mailCollector(messageHeader.recipients);
   if (messageHeader.ccList.length != 0) {mailCollector(messageHeader.ccList)};
   if (messageHeader.bccList.length != 0) {mailCollector(messageHeader.bccList)};

 for (let s=0; s<mailColl.length; s++) {
 const local_pic_src = await browser.FileSystem.readFile(mailColl[s], local_dir_path);
   if (!local_pic_src) {picLocalsrc.push("none");} else {picLocalsrc.push(local_pic_src);};
 };

for (let ab=0; ab<mailColl.length; ab++) {
 const scard = await browser.contacts.quickSearch(mailColl[ab]);
 if (scard.length<1) {picABsrc.push("none");} else {
   const photo_file = scard[0].properties.PhotoName;
     if ( photo_file ) {
       const AB_pic_src = await browser.FileSystem.readFile(photo_file, "AdrBook");
       picABsrc.push(AB_pic_src);
     }
     else {picABsrc.push("none");}
 }
};

 for (let f=0; f<mailColl.length; f++) {
   if (picLocalsrc[f] == "none" && picABsrc[f] == "none") {mailCollsrc.push(nophotoicon);}
   else
   {
     if (picLocalsrc[f] == "none" && picABsrc[f] !== "none") {mailCollsrc.push(picABsrc[f]);}
     else
     {
       if (picLocalsrc[f] !== "none" && picABsrc[f] == "none") {mailCollsrc.push(picLocalsrc[f]);}
       else
       {
         if (picLocalsrc[f] !== "none" && picABsrc[f] !== "none" && priority_place == "AB") {
         mailCollsrc.push(picABsrc[f])}
        else {
        mailCollsrc.push(picLocalsrc[f]);
        }
       }
     }
   }
};

  // check for known commands
  switch (command.toLocaleLowerCase()) {
    case "getnotificationdetails":
      {
        // create the information chunk we want to return to our message content script

        return {
          mailCollb: mailColl,
          mailCollFullb: mailCollFull,
          localpic: mailCollsrc,
        };
      }
      break;

/*    case "markunread":
      {
        // get the current message from the given tab
        if (messageHeader) {
          // mark the message as unread
          browser.messages.update(messageHeader.id, {
            read: false,
          });
        }
      }
*/      break;

  }
};


/**
 * handle the received message by filtering for all messages
 * whose "type" property is set to "command".
 */
const handleMessage = (message, sender, sendResponse) => {
  if (message && message.hasOwnProperty("command")) {
    // if we have a command, return a promise from the command handler
    return doHandleCommand(message, sender);
  }
};

// then to call it, you would use this

/**
 * Add a handler for communication with other parts of the extension,
 * like our messageDisplayScript.
 *
 * 👉 There should be only one handler in the background script
 *    for all incoming messages
*/
 browser.runtime.onMessage.addListener(handleMessage);

/**
 * Execute the startup handler whenever Thunderbird starts
 */
document.addEventListener("DOMContentLoaded", handleStartup);
